unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, OleCtrls, RealAudioObjects_TLB, StdCtrls;

type
    TTimerThread = class(TThread)
    protected
        procedure Kick();
        procedure Execute; override;
    end;

  TMainForm = class(TForm)
    StatusBar: TStatusBar;
    PnlPlayer: TPanel;
    SpacerTop: TPaintBox;
    SpacerBottom: TPaintBox;
    SpacerLeft: TPaintBox;
    SpacerRight: TPaintBox;
    FReal: TRealAudio;
    Panel2: TPanel;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Label1: TLabel;
    Memo1: TMemo;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    LblStatus: TLabel;
    Button10: TButton;
    Button5: TButton;
    Button11: TButton;
    Button12: TButton;
    ColorDialog1: TColorDialog;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FRealClipOpened(Sender: TObject; const shortClipName,
      url: WideString);
    procedure FRealClipClosed(Sender: TObject);
    procedure FRealPresentationClosed(Sender: TObject);
    procedure FRealPresentationOpened(Sender: TObject);
    procedure FRealBuffering(Sender: TObject; lFlags,
      lPercentage: Integer);
    procedure FormResize(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure FRealShowStatus(Sender: TObject;
      const statusText: WideString);
    procedure Button10Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure FRealTitleChange(Sender: TObject;
      const bstrTitle: WideString);
    procedure FRealAuthorChange(Sender: TObject;
      const bstrAuthor: WideString);
    procedure FRealCopyrightChange(Sender: TObject;
      const bstrCopyright: WideString);
  private
    FTimerThread: TTimerThread;
    FCounter: Integer;
    procedure UpdateForm();
    procedure ShowStatus(const S: string; const index: integer);
    procedure ShowDebug(const S: string);
  private
    procedure SetPlayerSize(const AClipW, AClipH: Integer);
    procedure WMEraseBkGnd(var Msg: TWMEraseBkgnd); message WM_ERASEBKGND;
  public
    { Public 錾 }
  end;

var
  MainForm: TMainForm;

implementation

uses
    Types, Info;

{$R *.dfm}

const
    INDEX_TIME = 0;

//=============================================================================
//  TTimerThread implementation
//=============================================================================

//-----------------------------------------------------------------------------
procedure TTimerThread.Kick();
begin
    MainForm.UpdateForm();
end;

//-----------------------------------------------------------------------------
procedure TTimerThread.Execute();
begin
    while not Terminated do
    begin
        Synchronize(Kick);
        Sleep(10);
    end;
end;

//=============================================================================
//  TMainForm implementation
//=============================================================================

//-----------------------------------------------------------------------------
//  h~
procedure TMainForm.WMEraseBkGnd(var Msg: TWMEraseBkgnd);
begin
    //
end;

//-----------------------------------------------------------------------------
//  Xe[^Xo[ɃbZ[W\
procedure TMainForm.ShowStatus(const S: string; const index: integer);
begin
    StatusBar.Panels[index].Text := S;
end;

//-----------------------------------------------------------------------------
//  TMemoɃbZ[W\
procedure TMainForm.ShowDebug(const S: string);
begin
    Memo1.Lines.Add(S);
end;

//-----------------------------------------------------------------------------
//  RXgN^
procedure TMainForm.FormCreate(Sender: TObject);
begin
    FCounter := 0;
    FTimerThread := TTimerThread.Create(False);

    Label1.Caption := 'RealPlayer Ver.' + FReal.GetVersionInfo;
end;

//-----------------------------------------------------------------------------
//  fXgN^
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    FTimerThread.Free();
end;

//-----------------------------------------------------------------------------
//  ^C}[
procedure TMainForm.UpdateForm();
var
    d1, d2: Double;
    s: String;
begin
    try
        //  ݂̃fBAڂ̕bŎĐ
        d1 := FReal.GetLength / 1000;
        //  fBAړ݈̌ʒu擾
        d2 := FReal.GetPosition / 1000;
        //  A
        s := Format('%fb / %fb', [d2, d1]);

        ShowStatus(s, INDEX_TIME);
    except
        on E: Exception do ShowDebug(E.Message);
    end;
end;

//-----------------------------------------------------------------------------
//  fBATCYɏcƂ[2008/02/05]
procedure TMainForm.SetPlayerSize(const AClipW, AClipH: Integer);
var
    LPlayerW: Integer;
    LPlayerH: Integer;
    LClipRatio: Double;
    LPlayerRatio: Double;
    LCalcW: Integer;
    LCalcH: Integer;
begin
    //  TCYȂ牽Ȃ
    if (AClipW * AClipH = 0) then Exit;

    //  vC[̂̃TCY
    LPlayerW := PnlPlayer.ClientWidth;
    LPlayerH := PnlPlayer.ClientHeight * 5 div 6;

    //  ɍ߂邩Aɕ߂邩
    LClipRatio := AClipW / AClipH;
    LPlayerRatio := LPlayerW / LPlayerH;

    //  c
    if (LClipRatio < LPlayerRatio) then
    begin
        //  c͖ڂςƂ
        SpacerTop.Height := 0;
        SpacerBottom.Height := 0;
        //  ̓fBA̔䗦Ō
        LCalcW := Round(LPlayerH * LClipRatio);
        SpacerLeft.Width := (LPlayerW - LCalcW) div 2;
        SpacerRight.Width := LPlayerW - LCalcW - SpacerLeft.Width; 
    end
    //  
    else
    begin
        //  ͖ڂςƂ
        SpacerLeft.Width := 0;
        SpacerRight.Width := 0;
        //  c̓fBA̔䗦Ō
        LCalcH := Round(LPlayerH / LClipRatio);
        SpacerTop.Height := (LPlayerH - LCalcH) div 2;
        SpacerBottom.Height := LPlayerH - LCalcH - SpacerTop.Height;
    end;
end;

//-----------------------------------------------------------------------------
procedure TMainForm.FRealTitleChange(Sender: TObject;
  const bstrTitle: WideString);
begin
    ShowDebug('TitleChange:' + bstrTitle);
end;

//-----------------------------------------------------------------------------
procedure TMainForm.FRealAuthorChange(Sender: TObject;
  const bstrAuthor: WideString);
begin
    ShowDebug('AuthorChange:' + bstrAuthor);
end;

//-----------------------------------------------------------------------------
procedure TMainForm.FRealCopyrightChange(Sender: TObject;
  const bstrCopyright: WideString);
begin
    ShowDebug('CopyrightChange:' + bstrCopyright);
end;

//-----------------------------------------------------------------------------
procedure TMainForm.FRealPresentationOpened(Sender: TObject);
begin
    ShowDebug('PresentationOpened');
end;

//-----------------------------------------------------------------------------
//  fBAJ(ȁH)
procedure TMainForm.FRealClipOpened(Sender: TObject; const shortClipName,
  url: WideString);
var
    LName: String;
    LWidth: Integer;
    LHeight: Integer;
begin
    ShowDebug('ClipOpened');

    LName := FReal.GetTitle;
    if (LName = '') then
    begin
        LName := ExtractFileName(shortClipName);
    end;

    //  N㏉߂Ă̂Ƃ͂ǂȂ[
    LWidth := FReal.GetClipWidth;
    LHeight := FReal.GetClipHeight;

    Self.Caption := Format('%s %dx%D %s', [Application.Title, LWidth, LHeight, LName]);
end;

//-----------------------------------------------------------------------------
//  tH[TCYύX
procedure TMainForm.FormResize(Sender: TObject);
var
    LWidth: Integer;
    LHeight: Integer;
begin
    LWidth := FReal.GetClipWidth;
    LHeight := FReal.GetClipHeight;

    //  ĐʃTCYݒ
    SetPlayerSize(LWidth, LHeight);
end;

//-----------------------------------------------------------------------------
procedure TMainForm.FRealBuffering(Sender: TObject; lFlags,
  lPercentage: Integer);
begin
    ShowDebug(Format('Buffering:%d%%', [lPercentage]));
end;

//-----------------------------------------------------------------------------
procedure TMainForm.FRealClipClosed(Sender: TObject);
begin
    ShowDebug('ClipClosed');
end;

//-----------------------------------------------------------------------------
procedure TMainForm.FRealPresentationClosed(Sender: TObject);
begin
    ShowDebug('PresentationClosed');
end;

//-----------------------------------------------------------------------------
//  t@CI
procedure TMainForm.Button1Click(Sender: TObject);
begin
    if (OpenDialog1.Execute()) then
    begin
        FReal.Source := OpenDialog1.FileName;
        FReal.DoPlay();
    end;
end;

//-----------------------------------------------------------------------------
//  ~[g
procedure TMainForm.Button2Click(Sender: TObject);
begin
    //  ~[gԐ؂ւ
    FReal.SetMute(not FReal.GetMute());
end;

//-----------------------------------------------------------------------------
//  AboutBox
procedure TMainForm.Button3Click(Sender: TObject);
begin
    FReal.AboutBox();
end;

//-----------------------------------------------------------------------------
procedure TMainForm.Button6Click(Sender: TObject);
begin
    //  ShowAbout ĂȂȂ ShowAbout (ƂӖ?)
    //  Ƃ Modal ŕ\邩炠܂ӖȂ
    FReal.SetShowAbout(not FReal.GetShowAbout());
end;

//-----------------------------------------------------------------------------
//  ݒ
procedure TMainForm.Button4Click(Sender: TObject);
begin
    FReal.EditPreferences();
end;

//-----------------------------------------------------------------------------
procedure TMainForm.Button7Click(Sender: TObject);
begin
    //  ShowPreferences ĂȂȂ ShowPreferences (ƂӖ?)
    //  łȂ
    FReal.SetShowPreferences(not FReal.GetShowPreferences());
end;

//-----------------------------------------------------------------------------
//  v
procedure TMainForm.Button8Click(Sender: TObject);
begin
    //  ShowStatistics ĂȂȂ ShowStatistics 
    FReal.SetShowStatistics(not FReal.GetShowStatistics());
end;

//-----------------------------------------------------------------------------
//  ReLXgj[
procedure TMainForm.Button9Click(Sender: TObject);
begin
    //  ReLXgj[̗L/؂ւꂻȂ̂...
    FReal.SetEnableContextMenu(not FReal.GetEnableContextMenu());
end;

//-----------------------------------------------------------------------------
//  󋵕\
procedure TMainForm.FRealShowStatus(Sender: TObject;
  const statusText: WideString);
begin
    LblStatus.Caption := Format('%d : %s', [FReal.GetPlayState, statusText]);
end;

//-----------------------------------------------------------------------------
//  tXN[Đ
procedure TMainForm.Button5Click(Sender: TObject);
begin
    if (AppMessageBox(
                'słB߂قǂB߂܂H'#13#10
                + 'ɉĐĂȂƂɎƂ悭ȂB',
                MB_ICONQUESTION or MB_YESNO) = ID_YES) then Exit;

    FReal.SetFullScreen();
end;

//-----------------------------------------------------------------------------
//  
procedure TMainForm.Button10Click(Sender: TObject);
begin
    //  悭킩ȂAFReal.GetLength (?)O
    //FReal.SetMaintainAspect(FReal.GetMaintainAspect());

    //  ωȂ
    //FReal.SetEnableOriginalSize(FReal.GetEnableOriginalSize());
    //FReal.SetEnableOriginalSize(True);

    //  ωȂ
    //FReal.SetEnableDoubleSize(FReal.GetEnableDoubleSize());
    //FReal.SetEnableDoubleSize(True);

    //  ωȂ
    //FReal.SetEnableFullScreen(FReal.GetEnableFullScreen());
    //FReal.SetEnableFullScreen(True);

    //  ωȂ
    //FReal.SetOriginalSize();
    //FReal.SetDoubleSize();

    //  ωȂ
    //FReal.SetNoLogo(not FReal.GetNoLogo());
    //FReal.SetNoLogo(False);

    //  ωȂ
    //FReal.SetImageStatus(not FReal.GetImageStatus());

    //  ωȂ
    //FReal.SetShowVideo(True);

    //  ωȂ
    //FReal.SetVideoOverlay(True);
end;

//-----------------------------------------------------------------------------
//  擾֌W
procedure TMainForm.Button11Click(Sender: TObject);
var
    LText: String;
begin
    LText := 'SȂłAĐɎĂB';
    if (FReal.CanPause()) then
    begin
        LText := 'Console:' + FReal.Console
         + #13#10'Controls:' + FReal.Controls
         + #13#10'Author:' + FReal.GetAuthor
         + #13#10'Copyright:' + FReal.GetCopyright
         + #13#10'PreferedLanguageString:' + FReal.GetPreferedLanguageString
         + #13#10'LastErrorUserString:' + FReal.GetLastErrorUserString
         + #13#10'Region:' + FReal.GetRegion
         + #13#10'WindowName:' + FReal.WindowName
         + #13#10'LastMessage:' + FReal.GetLastMessage
         ;
    end;
    AppMessageBox(LText, MB_ICONINFORMATION or MB_OK);
end;

//-----------------------------------------------------------------------------
//  TColorWebJ[(#FFFFFF)ɕϊ
function DelphiColor2WebColor(const AColor: TColor): String;
begin
    Result := Format('#%.2x%.2x%.2x',[GetRValue(AColor),
                                      GetGValue(AColor),
                                      GetBValue(AColor)]
                                      );
end;

//-----------------------------------------------------------------------------
//  WebJ[(#FFFFFF)TColorɕϊ
function WebColor2DelphiColor(const AColor: String): TColor;
var
    LR: String;
    LG: String;
    LB: String;
begin
    LR := '$' + Copy(AColor, 2, 2);
    LG := '$' + Copy(AColor, 4, 2);
    LB := '$' + Copy(AColor, 6, 2);
    Result := RGB(StrToIntDef(LR, 0), StrToIntDef(LG, 0), StrToIntDef(LB, 0));
end;

//-----------------------------------------------------------------------------
//  wiFύX
procedure TMainForm.Button12Click(Sender: TObject);
begin
    //  ǔwiȂ̂ł܂ɗȂ
    //  TCYύXƂɂ炿ƌ
    ColorDialog1.Color := WebColor2DelphiColor(FReal.GetBackgroundColor);
    if (ColorDialog1.Execute()) then
    begin
        FReal.SetBackgroundColor(DelphiColor2WebColor(ColorDialog1.Color));
    end;
end;

//-----------------------------------------------------------------------------
//  IWiTCYōĐ
procedure TMainForm.Button13Click(Sender: TObject);
begin
    //  Đ̃t@Cɂ͐؂ւȂ
    //  ɊJt@C(t@CJĂ߂݂)
    FReal.SetCenter(not FReal.GetCenter());
end;

//-----------------------------------------------------------------------------
//  30bXLbv
procedure TMainForm.Button14Click(Sender: TObject);
begin
    if (FReal.CanPause()) then
    begin
        FReal.SetPosition(FReal.GetPosition() + 30 * 1000);
    end;
end;

//-----------------------------------------------------------------------------
//  ĐEꎞ~؂ւ
procedure TMainForm.Button15Click(Sender: TObject);
begin
    if (FReal.CanPlay()) then
    begin
        FReal.DoPlay();
    end
    else
    if (FReal.CanPlayPause()) then
    begin
        FReal.DoPlayPause();
    end
    ;
end;

end.

